Require Import Ltac2.Ltac2.
Require OverEq.
Import OverEq.Notations.


(* demonstate that we have basic congruence working over eq *)

Lemma example_4_4_4: forall (f : nat -> nat) (x: nat), f (f (f x)) = x -> f (f x) = x -> f x = x.
Proof.
  intros.
  basicCongruence.
Qed.


Lemma itWorks:
  forall (o: nat -> nat -> nat)
          (x y: nat),
          o x y = o y x ->
          o x x = x ->
          o y y = y ->
          (o (o x x) (o y y)) = o (o x y) (o y x)
          <-> 
          (o (o x y) (o x y) = o x y).
Proof.
  intros.
  split.
  + intros. basicCongruence.
  + intros. basicCongruence.
Qed.

Module tst.

End tst.

